"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _path = _interopRequireDefault(require("path"));

var _identity = _interopRequireDefault(require("lodash/identity"));

var _getComponents = _interopRequireDefault(require("./getComponents"));

describe('getComponents', function () {
  it('should return an object for components', function () {
    var result = (0, _getComponents["default"])(['Foo.js', 'Bar.js'], {
      configDir: _path["default"].resolve(__dirname, '../../../test'),
      getExampleFilename: _identity["default"],
      getComponentPathLine: _identity["default"]
    });
    expect(result).toMatchObject([{
      slug: 'foo',
      module: {
        require: 'Foo.js'
      },
      props: {},
      hasExamples: false,
      metadata: {}
    }, {
      slug: 'bar',
      module: {
        require: 'Bar.js'
      },
      props: {},
      hasExamples: false,
      metadata: {}
    }]);
  });
});